/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { fetchEncodedAccount, fetchEncodedAccounts, type Account, type Address, type Codec, type Decoder, type EncodedAccount, type Encoder, type FetchAccountConfig, type FetchAccountsConfig, type MaybeAccount, type MaybeEncodedAccount, type ReadonlyUint8Array } from '@solana/web3.js';
import { type Currency, type CurrencyArgs, type NullableAddress, type NullableAddressArgs } from '../../hooked';
import { PoolSeeds } from '../pdas';
import { type PoolConfig, type PoolConfigArgs, type PoolStats, type PoolStatsArgs } from '../types';
export declare const POOL_DISCRIMINATOR: Uint8Array;
export declare function getPoolDiscriminatorBytes(): ReadonlyUint8Array;
export type Pool = {
    discriminator: ReadonlyUint8Array;
    /** Pool version, used to control upgrades. */
    version: number;
    /** Bump seed for the pool PDA. */
    bump: Array<number>;
    /** Owner-chosen identifier for the pool */
    poolId: ReadonlyUint8Array;
    /** Unix timestamp of the pool creation, in seconds. */
    createdAt: bigint;
    /** Unix timestamp of the last time the pool has been updated, in seconds. */
    updatedAt: bigint;
    /** Unix timestamp of when the pool expires, in seconds. */
    expiry: bigint;
    /** The owner of the pool. */
    owner: Address;
    /** The whitelist of the pool, determining which NFTs can be deposited or sold into the pool. */
    whitelist: Address;
    rentPayer: Address;
    currency: Currency;
    /** The amount of currency held in the pool. */
    amount: bigint;
    /**
     * The difference between the number of buys and sells
     * where a postive number indicates the taker has BOUGHT more NFTs than sold
     * and a negative number indicates the taker has SOLD more NFTs than bought.
     * This is used to calculate the current price of the pool.
     */
    priceOffset: number;
    /** The number of NFTs currently held in the pool. */
    nftsHeld: number;
    /** Various stats about the pool, including the number of buys and sells. */
    stats: PoolStats;
    /**
     * If an escrow account is present, it means it's a shared-escrow pool where liquidity is shared with other pools.
     * Default pubkey is interpreted as no value.
     */
    sharedEscrow: NullableAddress;
    /**
     * An offchain actor that signs off to make sure an offchain condition is met (eg trait present).
     * Default pubkey is interpreted as no value.
     */
    cosigner: NullableAddress;
    /**
     * Maker broker fees will be sent to this address if populated.
     * Default pubkey is interpreted as no value.
     */
    makerBroker: NullableAddress;
    /** Limit how many buys a pool can execute - useful for shared escrow pools, else keeps buying into infinity. */
    maxTakerSellCount: number;
    /** Pool configuration values. */
    config: PoolConfig;
    /** Reserved space for future upgrades. */
    reserved: Array<number>;
};
export type PoolArgs = {
    /** Pool version, used to control upgrades. */
    version: number;
    /** Bump seed for the pool PDA. */
    bump: Array<number>;
    /** Owner-chosen identifier for the pool */
    poolId: ReadonlyUint8Array;
    /** Unix timestamp of the pool creation, in seconds. */
    createdAt: number | bigint;
    /** Unix timestamp of the last time the pool has been updated, in seconds. */
    updatedAt: number | bigint;
    /** Unix timestamp of when the pool expires, in seconds. */
    expiry: number | bigint;
    /** The owner of the pool. */
    owner: Address;
    /** The whitelist of the pool, determining which NFTs can be deposited or sold into the pool. */
    whitelist: Address;
    rentPayer: Address;
    currency: CurrencyArgs;
    /** The amount of currency held in the pool. */
    amount: number | bigint;
    /**
     * The difference between the number of buys and sells
     * where a postive number indicates the taker has BOUGHT more NFTs than sold
     * and a negative number indicates the taker has SOLD more NFTs than bought.
     * This is used to calculate the current price of the pool.
     */
    priceOffset: number;
    /** The number of NFTs currently held in the pool. */
    nftsHeld: number;
    /** Various stats about the pool, including the number of buys and sells. */
    stats: PoolStatsArgs;
    /**
     * If an escrow account is present, it means it's a shared-escrow pool where liquidity is shared with other pools.
     * Default pubkey is interpreted as no value.
     */
    sharedEscrow: NullableAddressArgs;
    /**
     * An offchain actor that signs off to make sure an offchain condition is met (eg trait present).
     * Default pubkey is interpreted as no value.
     */
    cosigner: NullableAddressArgs;
    /**
     * Maker broker fees will be sent to this address if populated.
     * Default pubkey is interpreted as no value.
     */
    makerBroker: NullableAddressArgs;
    /** Limit how many buys a pool can execute - useful for shared escrow pools, else keeps buying into infinity. */
    maxTakerSellCount: number;
    /** Pool configuration values. */
    config: PoolConfigArgs;
    /** Reserved space for future upgrades. */
    reserved: Array<number>;
};
export declare function getPoolEncoder(): Encoder<PoolArgs>;
export declare function getPoolDecoder(): Decoder<Pool>;
export declare function getPoolCodec(): Codec<PoolArgs, Pool>;
export declare function decodePool<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Account<Pool, TAddress>;
export declare function decodePool<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeAccount<Pool, TAddress>;
export declare function fetchPool<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Account<Pool, TAddress>>;
export declare function fetchMaybePool<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeAccount<Pool, TAddress>>;
export declare function fetchAllPool(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Account<Pool>[]>;
export declare function fetchAllMaybePool(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeAccount<Pool>[]>;
export declare function getPoolSize(): number;
export declare function fetchPoolFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: PoolSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Account<Pool>>;
export declare function fetchMaybePoolFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: PoolSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeAccount<Pool>>;
//# sourceMappingURL=pool.d.ts.map