/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export declare const BUY_NFT_CORE_DISCRIMINATOR: Uint8Array;
export declare function getBuyNftCoreDiscriminatorBytes(): ReadonlyUint8Array;
export type BuyNftCoreInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountTaker extends string | IAccountMeta<string> = string, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountSharedEscrow extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountAmmProgram extends string | IAccountMeta<string> = 'TAMM6ub33ij1mbetoMyVBLeKY5iP41i4UPUJQGkhfsg', TAccountEscrowProgram extends string | IAccountMeta<string> = string, TAccountNativeProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountMplCoreProgram extends string | IAccountMeta<string> = 'CoREENxT6tW1HoK8ypY1SxRMZTcVPm7R94rH4PZNhX7d', TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountTaker extends string ? WritableSignerAccount<TAccountTaker> & IAccountSignerMeta<TAccountTaker> : TAccountTaker,
    TAccountRentPayer extends string ? WritableAccount<TAccountRentPayer> : TAccountRentPayer,
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountSharedEscrow extends string ? WritableAccount<TAccountSharedEscrow> : TAccountSharedEscrow,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountAmmProgram extends string ? ReadonlyAccount<TAccountAmmProgram> : TAccountAmmProgram,
    TAccountEscrowProgram extends string ? ReadonlyAccount<TAccountEscrowProgram> : TAccountEscrowProgram,
    TAccountNativeProgram extends string ? ReadonlyAccount<TAccountNativeProgram> : TAccountNativeProgram,
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? ReadonlyAccount<TAccountCollection> : TAccountCollection,
    TAccountMplCoreProgram extends string ? ReadonlyAccount<TAccountMplCoreProgram> : TAccountMplCoreProgram,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type BuyNftCoreInstructionData = {
    discriminator: ReadonlyUint8Array;
    maxAmount: bigint;
};
export type BuyNftCoreInstructionDataArgs = {
    maxAmount: number | bigint;
};
export declare function getBuyNftCoreInstructionDataEncoder(): Encoder<BuyNftCoreInstructionDataArgs>;
export declare function getBuyNftCoreInstructionDataDecoder(): Decoder<BuyNftCoreInstructionData>;
export declare function getBuyNftCoreInstructionDataCodec(): Codec<BuyNftCoreInstructionDataArgs, BuyNftCoreInstructionData>;
export type BuyNftCoreAsyncInput<TAccountOwner extends string = string, TAccountTaker extends string = string, TAccountRentPayer extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string, TAccountEscrowProgram extends string = string, TAccountNativeProgram extends string = string, TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountMplCoreProgram extends string = string, TAccountNftReceipt extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the buyer/recipient of the NFT. */
    owner: Address<TAccountOwner>;
    /** The taker is the user buying or selling the NFT. */
    taker: TransactionSigner<TAccountTaker>;
    /**
     * The original rent payer of the pool--stored on the pool. Used to refund rent in case the pool
     * is auto-closed.
     */
    rentPayer?: Address<TAccountRentPayer>;
    /** Fee vault account owned by the TFEE program. */
    feeVault?: Address<TAccountFeeVault>;
    /**
     * The Pool state account that the NFT is being sold into. Stores pool state and config,
     * but is also the owner of any NFTs in the pool, and also escrows any SOL.
     * Any active pool can be specified provided it is a Token type and the NFT passes at least one
     * whitelist condition.
     */
    pool: Address<TAccountPool>;
    /** The whitelist account that the pool uses to verify the NFTs being sold into it. */
    whitelist?: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The shared escrow account for pools that have liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /** The optional cosigner account that must be passed in if the pool has a cosigner. */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    /** The escrow program account for shared liquidity pools. */
    escrowProgram?: Address<TAccountEscrowProgram>;
    nativeProgram?: Address<TAccountNativeProgram>;
    /** The MPL core asset account. */
    asset: Address<TAccountAsset>;
    collection?: Address<TAccountCollection>;
    /** The MPL Core program. */
    mplCoreProgram?: Address<TAccountMplCoreProgram>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    maxAmount: BuyNftCoreInstructionDataArgs['maxAmount'];
    creators?: Array<Address>;
};
export declare function getBuyNftCoreInstructionAsync<TAccountOwner extends string, TAccountTaker extends string, TAccountRentPayer extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string, TAccountEscrowProgram extends string, TAccountNativeProgram extends string, TAccountAsset extends string, TAccountCollection extends string, TAccountMplCoreProgram extends string, TAccountNftReceipt extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: BuyNftCoreAsyncInput<TAccountOwner, TAccountTaker, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram, TAccountNativeProgram, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): Promise<BuyNftCoreInstruction<TProgramAddress, TAccountOwner, TAccountTaker, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram, TAccountNativeProgram, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt, TAccountSystemProgram>>;
export type BuyNftCoreInput<TAccountOwner extends string = string, TAccountTaker extends string = string, TAccountRentPayer extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string, TAccountEscrowProgram extends string = string, TAccountNativeProgram extends string = string, TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountMplCoreProgram extends string = string, TAccountNftReceipt extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the buyer/recipient of the NFT. */
    owner: Address<TAccountOwner>;
    /** The taker is the user buying or selling the NFT. */
    taker: TransactionSigner<TAccountTaker>;
    /**
     * The original rent payer of the pool--stored on the pool. Used to refund rent in case the pool
     * is auto-closed.
     */
    rentPayer?: Address<TAccountRentPayer>;
    /** Fee vault account owned by the TFEE program. */
    feeVault: Address<TAccountFeeVault>;
    /**
     * The Pool state account that the NFT is being sold into. Stores pool state and config,
     * but is also the owner of any NFTs in the pool, and also escrows any SOL.
     * Any active pool can be specified provided it is a Token type and the NFT passes at least one
     * whitelist condition.
     */
    pool: Address<TAccountPool>;
    /** The whitelist account that the pool uses to verify the NFTs being sold into it. */
    whitelist?: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The shared escrow account for pools that have liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /** The optional cosigner account that must be passed in if the pool has a cosigner. */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    /** The escrow program account for shared liquidity pools. */
    escrowProgram?: Address<TAccountEscrowProgram>;
    nativeProgram?: Address<TAccountNativeProgram>;
    /** The MPL core asset account. */
    asset: Address<TAccountAsset>;
    collection?: Address<TAccountCollection>;
    /** The MPL Core program. */
    mplCoreProgram?: Address<TAccountMplCoreProgram>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    maxAmount: BuyNftCoreInstructionDataArgs['maxAmount'];
    creators?: Array<Address>;
};
export declare function getBuyNftCoreInstruction<TAccountOwner extends string, TAccountTaker extends string, TAccountRentPayer extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string, TAccountEscrowProgram extends string, TAccountNativeProgram extends string, TAccountAsset extends string, TAccountCollection extends string, TAccountMplCoreProgram extends string, TAccountNftReceipt extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: BuyNftCoreInput<TAccountOwner, TAccountTaker, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram, TAccountNativeProgram, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): BuyNftCoreInstruction<TProgramAddress, TAccountOwner, TAccountTaker, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram, TAccountNativeProgram, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt, TAccountSystemProgram>;
export type ParsedBuyNftCoreInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the buyer/recipient of the NFT. */
        owner: TAccountMetas[0];
        /** The taker is the user buying or selling the NFT. */
        taker: TAccountMetas[1];
        /**
         * The original rent payer of the pool--stored on the pool. Used to refund rent in case the pool
         * is auto-closed.
         */
        rentPayer: TAccountMetas[2];
        /** Fee vault account owned by the TFEE program. */
        feeVault: TAccountMetas[3];
        /**
         * The Pool state account that the NFT is being sold into. Stores pool state and config,
         * but is also the owner of any NFTs in the pool, and also escrows any SOL.
         * Any active pool can be specified provided it is a Token type and the NFT passes at least one
         * whitelist condition.
         */
        pool: TAccountMetas[4];
        /** The whitelist account that the pool uses to verify the NFTs being sold into it. */
        whitelist?: TAccountMetas[5] | undefined;
        /**
         * Optional account which must be passed in if the NFT must be verified against a
         * merkle proof condition in the whitelist.
         */
        mintProof?: TAccountMetas[6] | undefined;
        /** The shared escrow account for pools that have liquidity in a shared account. */
        sharedEscrow?: TAccountMetas[7] | undefined;
        /** The account that receives the maker broker fee. */
        makerBroker?: TAccountMetas[8] | undefined;
        /** The account that receives the taker broker fee. */
        takerBroker?: TAccountMetas[9] | undefined;
        /** The optional cosigner account that must be passed in if the pool has a cosigner. */
        cosigner?: TAccountMetas[10] | undefined;
        /** The AMM program account, used for self-cpi logging. */
        ammProgram: TAccountMetas[11];
        /** The escrow program account for shared liquidity pools. */
        escrowProgram?: TAccountMetas[12] | undefined;
        nativeProgram: TAccountMetas[13];
        /** The MPL core asset account. */
        asset: TAccountMetas[14];
        collection?: TAccountMetas[15] | undefined;
        /** The MPL Core program. */
        mplCoreProgram: TAccountMetas[16];
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[17];
        /** The Solana system program. */
        systemProgram: TAccountMetas[18];
    };
    data: BuyNftCoreInstructionData;
};
export declare function parseBuyNftCoreInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBuyNftCoreInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=buyNftCore.d.ts.map