/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export declare const CLOSE_POOL_DISCRIMINATOR: Uint8Array;
export declare function getClosePoolDiscriminatorBytes(): ReadonlyUint8Array;
export type ClosePoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountRentPayer extends string ? WritableAccount<TAccountRentPayer> : TAccountRentPayer,
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type ClosePoolInstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type ClosePoolInstructionDataArgs = {};
export declare function getClosePoolInstructionDataEncoder(): Encoder<ClosePoolInstructionDataArgs>;
export declare function getClosePoolInstructionDataDecoder(): Decoder<ClosePoolInstructionData>;
export declare function getClosePoolInstructionDataCodec(): Codec<ClosePoolInstructionDataArgs, ClosePoolInstructionData>;
export type ClosePoolInput<TAccountRentPayer extends string = string, TAccountOwner extends string = string, TAccountPool extends string = string, TAccountSystemProgram extends string = string> = {
    /** The rent payer to refund pool rent to. */
    rentPayer?: Address<TAccountRentPayer>;
    /** The owner must sign to close the pool. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to close. */
    pool: Address<TAccountPool>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getClosePoolInstruction<TAccountRentPayer extends string, TAccountOwner extends string, TAccountPool extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: ClosePoolInput<TAccountRentPayer, TAccountOwner, TAccountPool, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): ClosePoolInstruction<TProgramAddress, TAccountRentPayer, TAccountOwner, TAccountPool, TAccountSystemProgram>;
export type ParsedClosePoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The rent payer to refund pool rent to. */
        rentPayer: TAccountMetas[0];
        /** The owner must sign to close the pool. */
        owner: TAccountMetas[1];
        /** The pool to close. */
        pool: TAccountMetas[2];
        /** The Solana system program. */
        systemProgram: TAccountMetas[3];
    };
    data: ClosePoolInstructionData;
};
export declare function parseClosePoolInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedClosePoolInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closePool.d.ts.map