/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export declare const DEPOSIT_NFT_T22_DISCRIMINATOR: Uint8Array;
export declare function getDepositNftT22DiscriminatorBytes(): ReadonlyUint8Array;
export type DepositNftT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type DepositNftT22InstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type DepositNftT22InstructionDataArgs = {};
export declare function getDepositNftT22InstructionDataEncoder(): Encoder<DepositNftT22InstructionDataArgs>;
export declare function getDepositNftT22InstructionDataDecoder(): Decoder<DepositNftT22InstructionData>;
export declare function getDepositNftT22InstructionDataCodec(): Codec<DepositNftT22InstructionDataArgs, DepositNftT22InstructionData>;
export type DepositNftT22AsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountNftReceipt extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool the NFT is being transferred to/from. */
    pool: Address<TAccountPool>;
    /**
     * The whitelist that gatekeeps which NFTs can be deposited into the pool.
     * Must match the whitelist stored in the pool state.
     */
    whitelist: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The mint account of the NFT. */
    mint: Address<TAccountMint>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The TA of the owner, where the NFT will be transferred from. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT will be escrowed. */
    poolTa?: Address<TAccountPoolTa>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    transferHookAccounts: Array<Address>;
};
export declare function getDepositNftT22InstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountNftReceipt extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: DepositNftT22AsyncInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): Promise<DepositNftT22Instruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>>;
export type DepositNftT22Input<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountNftReceipt extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool the NFT is being transferred to/from. */
    pool: Address<TAccountPool>;
    /**
     * The whitelist that gatekeeps which NFTs can be deposited into the pool.
     * Must match the whitelist stored in the pool state.
     */
    whitelist: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The mint account of the NFT. */
    mint: Address<TAccountMint>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The TA of the owner, where the NFT will be transferred from. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT will be escrowed. */
    poolTa: Address<TAccountPoolTa>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    transferHookAccounts: Array<Address>;
};
export declare function getDepositNftT22Instruction<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountNftReceipt extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: DepositNftT22Input<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): DepositNftT22Instruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>;
export type ParsedDepositNftT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the NFT. */
        owner: TAccountMetas[0];
        /** The pool the NFT is being transferred to/from. */
        pool: TAccountMetas[1];
        /**
         * The whitelist that gatekeeps which NFTs can be deposited into the pool.
         * Must match the whitelist stored in the pool state.
         */
        whitelist: TAccountMetas[2];
        /**
         * Optional account which must be passed in if the NFT must be verified against a
         * merkle proof condition in the whitelist.
         */
        mintProof?: TAccountMetas[3] | undefined;
        /** The mint account of the NFT. */
        mint: TAccountMetas[4];
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[5];
        /** The TA of the owner, where the NFT will be transferred from. */
        ownerTa: TAccountMetas[6];
        /** The TA of the pool, where the NFT will be escrowed. */
        poolTa: TAccountMetas[7];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[8];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[9];
        /** The Solana system program. */
        systemProgram: TAccountMetas[10];
    };
    data: DepositNftT22InstructionData;
};
export declare function parseDepositNftT22Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDepositNftT22Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=depositNftT22.d.ts.map