/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export declare const DEPOSIT_SOL_DISCRIMINATOR: Uint8Array;
export declare function getDepositSolDiscriminatorBytes(): ReadonlyUint8Array;
export type DepositSolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type DepositSolInstructionData = {
    discriminator: ReadonlyUint8Array;
    lamports: bigint;
};
export type DepositSolInstructionDataArgs = {
    lamports: number | bigint;
};
export declare function getDepositSolInstructionDataEncoder(): Encoder<DepositSolInstructionDataArgs>;
export declare function getDepositSolInstructionDataDecoder(): Decoder<DepositSolInstructionData>;
export declare function getDepositSolInstructionDataCodec(): Codec<DepositSolInstructionDataArgs, DepositSolInstructionData>;
export type DepositSolInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool--must sign to deposit SOL. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to deposit the SOL into. */
    pool: Address<TAccountPool>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    lamports: DepositSolInstructionDataArgs['lamports'];
};
export declare function getDepositSolInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: DepositSolInput<TAccountOwner, TAccountPool, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): DepositSolInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountSystemProgram>;
export type ParsedDepositSolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool--must sign to deposit SOL. */
        owner: TAccountMetas[0];
        /** The pool to deposit the SOL into. */
        pool: TAccountMetas[1];
        /** The Solana system program. */
        systemProgram: TAccountMetas[2];
    };
    data: DepositSolInstructionData;
};
export declare function parseDepositSolInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDepositSolInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=depositSol.d.ts.map