/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
import { type EditPoolConfig, type EditPoolConfigArgs } from '../types';
export declare const EDIT_POOL_DISCRIMINATOR: Uint8Array;
export declare function getEditPoolDiscriminatorBytes(): ReadonlyUint8Array;
export type EditPoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? ReadonlySignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type EditPoolInstructionData = {
    discriminator: ReadonlyUint8Array;
    newConfig: Option<EditPoolConfig>;
    cosigner: Option<Address>;
    makerBroker: Option<Address>;
    expireInSec: Option<bigint>;
    maxTakerSellCount: Option<number>;
    resetPriceOffset: boolean;
};
export type EditPoolInstructionDataArgs = {
    newConfig: OptionOrNullable<EditPoolConfigArgs>;
    cosigner?: OptionOrNullable<Address>;
    makerBroker?: OptionOrNullable<Address>;
    expireInSec?: OptionOrNullable<number | bigint>;
    maxTakerSellCount?: OptionOrNullable<number>;
    resetPriceOffset: boolean;
};
export declare function getEditPoolInstructionDataEncoder(): Encoder<EditPoolInstructionDataArgs>;
export declare function getEditPoolInstructionDataDecoder(): Decoder<EditPoolInstructionData>;
export declare function getEditPoolInstructionDataCodec(): Codec<EditPoolInstructionDataArgs, EditPoolInstructionData>;
export type EditPoolInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool--must sign to edit the pool. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to edit. */
    pool: Address<TAccountPool>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    newConfig: EditPoolInstructionDataArgs['newConfig'];
    cosigner?: EditPoolInstructionDataArgs['cosigner'];
    makerBroker?: EditPoolInstructionDataArgs['makerBroker'];
    expireInSec?: EditPoolInstructionDataArgs['expireInSec'];
    maxTakerSellCount?: EditPoolInstructionDataArgs['maxTakerSellCount'];
    resetPriceOffset: EditPoolInstructionDataArgs['resetPriceOffset'];
};
export declare function getEditPoolInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: EditPoolInput<TAccountOwner, TAccountPool, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): EditPoolInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountSystemProgram>;
export type ParsedEditPoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool--must sign to edit the pool. */
        owner: TAccountMetas[0];
        /** The pool to edit. */
        pool: TAccountMetas[1];
        /** The Solana system program. */
        systemProgram: TAccountMetas[2];
    };
    data: EditPoolInstructionData;
};
export declare function parseEditPoolInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedEditPoolInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=editPool.d.ts.map