/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { type TokenStandardArgs } from '@tensor-foundation/mpl-token-metadata';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
import { type AuthorizationDataLocal, type AuthorizationDataLocalArgs } from '../types';
export declare const WITHDRAW_NFT_DISCRIMINATOR: Uint8Array;
export declare function getWithdrawNftDiscriminatorBytes(): ReadonlyUint8Array;
export type WithdrawNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountUserTokenRecord extends string | IAccountMeta<string> = string, TAccountPoolTokenRecord extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = string, TAccountSysvarInstructions extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountUserTokenRecord extends string ? WritableAccount<TAccountUserTokenRecord> : TAccountUserTokenRecord,
    TAccountPoolTokenRecord extends string ? WritableAccount<TAccountPoolTokenRecord> : TAccountPoolTokenRecord,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type WithdrawNftInstructionData = {
    discriminator: ReadonlyUint8Array;
    authorizationData: Option<AuthorizationDataLocal>;
};
export type WithdrawNftInstructionDataArgs = {
    authorizationData?: OptionOrNullable<AuthorizationDataLocalArgs>;
};
export declare function getWithdrawNftInstructionDataEncoder(): Encoder<WithdrawNftInstructionDataArgs>;
export declare function getWithdrawNftInstructionDataDecoder(): Decoder<WithdrawNftInstructionData>;
export declare function getWithdrawNftInstructionDataCodec(): Codec<WithdrawNftInstructionDataArgs, WithdrawNftInstructionData>;
export type WithdrawNftInstructionExtraArgs = {
    tokenStandard?: TokenStandardArgs;
};
export type WithdrawNftAsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountUserTokenRecord extends string = string, TAccountPoolTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountNftReceipt extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool the NFT is being transferred to/from. */
    pool: Address<TAccountPool>;
    /**
     * The whitelist that gatekeeps which NFTs can be deposited into the pool.
     * Must match the whitelist stored in the pool state.
     */
    whitelist?: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The mint account of the NFT. */
    mint: Address<TAccountMint>;
    /** The Token Metadata metadata account of the NFT. */
    metadata?: Address<TAccountMetadata>;
    /** The Token Metadata edition account of the NFT. */
    edition?: Address<TAccountEdition>;
    /** The Token Metadata source token record account of the NFT. */
    userTokenRecord?: Address<TAccountUserTokenRecord>;
    /** The Token Metadata token record for the destination. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The TA of the owner, where the NFT will be transferred to as a result of this action. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT token is escrowed. */
    poolTa?: Address<TAccountPoolTa>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    authorizationData?: WithdrawNftInstructionDataArgs['authorizationData'];
    tokenStandard?: WithdrawNftInstructionExtraArgs['tokenStandard'];
};
export declare function getWithdrawNftInstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountUserTokenRecord extends string, TAccountPoolTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string, TAccountNftReceipt extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: WithdrawNftAsyncInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountMetadata, TAccountEdition, TAccountUserTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): Promise<WithdrawNftInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountMetadata, TAccountEdition, TAccountUserTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>>;
export type WithdrawNftInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountUserTokenRecord extends string = string, TAccountPoolTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountNftReceipt extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool the NFT is being transferred to/from. */
    pool: Address<TAccountPool>;
    /**
     * The whitelist that gatekeeps which NFTs can be deposited into the pool.
     * Must match the whitelist stored in the pool state.
     */
    whitelist?: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The mint account of the NFT. */
    mint: Address<TAccountMint>;
    /** The Token Metadata metadata account of the NFT. */
    metadata: Address<TAccountMetadata>;
    /** The Token Metadata edition account of the NFT. */
    edition: Address<TAccountEdition>;
    /** The Token Metadata source token record account of the NFT. */
    userTokenRecord?: Address<TAccountUserTokenRecord>;
    /** The Token Metadata token record for the destination. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The TA of the owner, where the NFT will be transferred to as a result of this action. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT token is escrowed. */
    poolTa: Address<TAccountPoolTa>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    authorizationData?: WithdrawNftInstructionDataArgs['authorizationData'];
    tokenStandard?: WithdrawNftInstructionExtraArgs['tokenStandard'];
};
export declare function getWithdrawNftInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountUserTokenRecord extends string, TAccountPoolTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string, TAccountNftReceipt extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: WithdrawNftInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountMetadata, TAccountEdition, TAccountUserTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): WithdrawNftInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountMetadata, TAccountEdition, TAccountUserTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountNftReceipt, TAccountOwnerTa, TAccountPoolTa, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>;
export type ParsedWithdrawNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the NFT. */
        owner: TAccountMetas[0];
        /** The pool the NFT is being transferred to/from. */
        pool: TAccountMetas[1];
        /**
         * The whitelist that gatekeeps which NFTs can be deposited into the pool.
         * Must match the whitelist stored in the pool state.
         */
        whitelist?: TAccountMetas[2] | undefined;
        /**
         * Optional account which must be passed in if the NFT must be verified against a
         * merkle proof condition in the whitelist.
         */
        mintProof?: TAccountMetas[3] | undefined;
        /** The mint account of the NFT. */
        mint: TAccountMetas[4];
        /** The Token Metadata metadata account of the NFT. */
        metadata: TAccountMetas[5];
        /** The Token Metadata edition account of the NFT. */
        edition: TAccountMetas[6];
        /** The Token Metadata source token record account of the NFT. */
        userTokenRecord?: TAccountMetas[7] | undefined;
        /** The Token Metadata token record for the destination. */
        poolTokenRecord?: TAccountMetas[8] | undefined;
        /** The Token Metadata program account. */
        tokenMetadataProgram?: TAccountMetas[9] | undefined;
        /** The sysvar instructions account. */
        sysvarInstructions?: TAccountMetas[10] | undefined;
        /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
        authorizationRules?: TAccountMetas[11] | undefined;
        /** The Metaplex Token Authority Rules program account. */
        authorizationRulesProgram?: TAccountMetas[12] | undefined;
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[13];
        /** The TA of the owner, where the NFT will be transferred to as a result of this action. */
        ownerTa: TAccountMetas[14];
        /** The TA of the pool, where the NFT token is escrowed. */
        poolTa: TAccountMetas[15];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[16];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[17];
        /** The Solana system program. */
        systemProgram: TAccountMetas[18];
    };
    data: WithdrawNftInstructionData;
};
export declare function parseWithdrawNftInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWithdrawNftInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=withdrawNft.d.ts.map