/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export declare const WITHDRAW_NFT_CORE_DISCRIMINATOR: Uint8Array;
export declare function getWithdrawNftCoreDiscriminatorBytes(): ReadonlyUint8Array;
export type WithdrawNftCoreInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountMplCoreProgram extends string | IAccountMeta<string> = 'CoREENxT6tW1HoK8ypY1SxRMZTcVPm7R94rH4PZNhX7d', TAccountNftReceipt extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? ReadonlyAccount<TAccountCollection> : TAccountCollection,
    TAccountMplCoreProgram extends string ? ReadonlyAccount<TAccountMplCoreProgram> : TAccountMplCoreProgram,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    ...TRemainingAccounts
]>;
export type WithdrawNftCoreInstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type WithdrawNftCoreInstructionDataArgs = {};
export declare function getWithdrawNftCoreInstructionDataEncoder(): Encoder<WithdrawNftCoreInstructionDataArgs>;
export declare function getWithdrawNftCoreInstructionDataDecoder(): Decoder<WithdrawNftCoreInstructionData>;
export declare function getWithdrawNftCoreInstructionDataCodec(): Codec<WithdrawNftCoreInstructionDataArgs, WithdrawNftCoreInstructionData>;
export type WithdrawNftCoreAsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountMplCoreProgram extends string = string, TAccountNftReceipt extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool the NFT is being transferred to/from. */
    pool: Address<TAccountPool>;
    /**
     * The whitelist that gatekeeps which NFTs can be deposited into the pool.
     * Must match the whitelist stored in the pool state.
     */
    whitelist?: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The MPL core asset account. */
    asset: Address<TAccountAsset>;
    collection?: Address<TAccountCollection>;
    /** The MPL Core program. */
    mplCoreProgram?: Address<TAccountMplCoreProgram>;
    /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
    nftReceipt?: Address<TAccountNftReceipt>;
};
export declare function getWithdrawNftCoreInstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountAsset extends string, TAccountCollection extends string, TAccountMplCoreProgram extends string, TAccountNftReceipt extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: WithdrawNftCoreAsyncInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt>, config?: {
    programAddress?: TProgramAddress;
}): Promise<WithdrawNftCoreInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt>>;
export type WithdrawNftCoreInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountMplCoreProgram extends string = string, TAccountNftReceipt extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool the NFT is being transferred to/from. */
    pool: Address<TAccountPool>;
    /**
     * The whitelist that gatekeeps which NFTs can be deposited into the pool.
     * Must match the whitelist stored in the pool state.
     */
    whitelist?: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The MPL core asset account. */
    asset: Address<TAccountAsset>;
    collection?: Address<TAccountCollection>;
    /** The MPL Core program. */
    mplCoreProgram?: Address<TAccountMplCoreProgram>;
    /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
    nftReceipt: Address<TAccountNftReceipt>;
};
export declare function getWithdrawNftCoreInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountAsset extends string, TAccountCollection extends string, TAccountMplCoreProgram extends string, TAccountNftReceipt extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: WithdrawNftCoreInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt>, config?: {
    programAddress?: TProgramAddress;
}): WithdrawNftCoreInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountAsset, TAccountCollection, TAccountMplCoreProgram, TAccountNftReceipt>;
export type ParsedWithdrawNftCoreInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the NFT. */
        owner: TAccountMetas[0];
        /** The pool the NFT is being transferred to/from. */
        pool: TAccountMetas[1];
        /**
         * The whitelist that gatekeeps which NFTs can be deposited into the pool.
         * Must match the whitelist stored in the pool state.
         */
        whitelist?: TAccountMetas[2] | undefined;
        /**
         * Optional account which must be passed in if the NFT must be verified against a
         * merkle proof condition in the whitelist.
         */
        mintProof?: TAccountMetas[3] | undefined;
        /** The MPL core asset account. */
        asset: TAccountMetas[4];
        collection?: TAccountMetas[5] | undefined;
        /** The MPL Core program. */
        mplCoreProgram: TAccountMetas[6];
        /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
        nftReceipt: TAccountMetas[7];
    };
    data: WithdrawNftCoreInstructionData;
};
export declare function parseWithdrawNftCoreInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWithdrawNftCoreInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=withdrawNftCore.d.ts.map