/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export declare const WITHDRAW_SOL_DISCRIMINATOR: Uint8Array;
export declare function getWithdrawSolDiscriminatorBytes(): ReadonlyUint8Array;
export type WithdrawSolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type WithdrawSolInstructionData = {
    discriminator: ReadonlyUint8Array;
    lamports: bigint;
};
export type WithdrawSolInstructionDataArgs = {
    lamports: number | bigint;
};
export declare function getWithdrawSolInstructionDataEncoder(): Encoder<WithdrawSolInstructionDataArgs>;
export declare function getWithdrawSolInstructionDataDecoder(): Decoder<WithdrawSolInstructionData>;
export declare function getWithdrawSolInstructionDataCodec(): Codec<WithdrawSolInstructionDataArgs, WithdrawSolInstructionData>;
export type WithdrawSolInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and will receive the SOL. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool from which the SOL will be withdrawn. */
    pool: Address<TAccountPool>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    lamports: WithdrawSolInstructionDataArgs['lamports'];
};
export declare function getWithdrawSolInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof TENSOR_AMM_PROGRAM_ADDRESS>(input: WithdrawSolInput<TAccountOwner, TAccountPool, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): WithdrawSolInstruction<TProgramAddress, TAccountOwner, TAccountPool, TAccountSystemProgram>;
export type ParsedWithdrawSolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and will receive the SOL. */
        owner: TAccountMetas[0];
        /** The pool from which the SOL will be withdrawn. */
        pool: TAccountMetas[1];
        /** The Solana system program. */
        systemProgram: TAccountMetas[2];
    };
    data: WithdrawSolInstructionData;
};
export declare function parseWithdrawSolInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWithdrawSolInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=withdrawSol.d.ts.map